package com.goafanti.common.dao;

import com.goafanti.common.model.UserInterviewProject;
import com.goafanti.common.model.UserInterviewProjectBo;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 客户面谈项目表(UserInterviewProject)表数据库访问层
 *
 * @author makejava
 * @since 2025-04-11 11:01:29
 */
public interface UserInterviewProjectMapper {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    UserInterviewProject selectById(Integer id);


    /**
     * 查询指定行数据
     *
     * @param userInterviewProject 查询条件
     * @return 对象列表
     */
    List<UserInterviewProject> findUserInterviewProjectList(UserInterviewProject userInterviewProject);

    /**
     * 统计总行数
     *
     * @param userInterviewProject 查询条件
     * @return 总行数
     */
    int findUserInterviewProjectCount(UserInterviewProject userInterviewProject);

    /**
     * 新增数据
     *
     * @param userInterviewProject 实例对象
     * @return 影响行数
     */
    int insert(UserInterviewProject userInterviewProject);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<UserInterviewProject> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<UserInterviewProject> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<UserInterviewProject> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<UserInterviewProject> entities);

    /**
     * 修改数据
     *
     * @param userInterviewProject 实例对象
     * @return 影响行数
     */
    int update(UserInterviewProject userInterviewProject);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    List<UserInterviewProjectBo> selectByAid(@Param("aid") String aid, @Param("uid") String uid);

    void updateByPrdId(@Param("id") Integer id, @Param("status") Integer status);

    List<UserInterviewProjectBo> selectByPrdId(Integer prdId);
}

